MODULE_NAME='ChristieDigital_DS60_UI'(DEV vdvDS60, DEV dvTPArray[], 
                                INTEGER nTPButtons[])

(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 10/25/2004 AT: 11:20:06               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/15/2006  AT: 19:30:31        *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 10/25/2004                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

DEFINE_DEVICE

DEFINE_CONSTANT

DEFINE_TYPE


DEFINE_VARIABLE
VOLATILE CHAR bDebug
VOLATILE CHAR sDirect[3] = ''     // used to store direct tune value 
VOLATILE INTEGER nPower   
VOLATILE INTEGER nInput
VOLATILE INTEGER nAspect
VOLATILE INTEGER nBrightness
VOLATILE INTEGER nColor
VOLATILE INTEGER nContrast
VOLATILE INTEGER nTint
VOLATILE CHAR    cVersion[5]

DEFINE_LATCHING

DEFINE_MUTUALLY_EXCLUSIVE

DEFINE_START

DEFINE_EVENT

BUTTON_EVENT[dvTPArray, nTPButtons]
{
    PUSH:
    {
        STACK_VAR CHAR nBtnIndex                        // no more than 4096 buttons in the array 
        STACK_VAR CHAR nDevice
                              
        nBtnIndex = GET_LAST(nTPButtons)
	SEND_STRING 0,"ITOA(nBtnIndex)"
        PULSE [dvTPArray,nTPButtons[nBtnIndex]]
        SWITCH (nBtnIndex)
        {
            CASE 1: // power 
            {
	    
		IF (nPOWER)
		{
		    SEND_COMMAND vdvDS60, "'POWER=0'"
		}
		ELSE
		{
		    SEND_COMMAND vdvDS60, "'POWER=1'"
		}		
            }
            CASE 2:  
            {
                SEND_COMMAND vdvDS60, "'ASPECT=1'"
            }
            CASE 3:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=2'"
 
            }
            CASE 4:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=3'"
            }
            CASE 5:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=4'"
            }
            CASE 6:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=5'"
            }
            CASE 7:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=6'"
            }
            CASE 8:
            {
                SEND_COMMAND vdvDS60, "'ASPECT=7'"
            }
            CASE 9:
            {
                SEND_COMMAND vdvDS60, "'INPUT=0'"
            }
            CASE 10:
            {
                SEND_COMMAND vdvDS60, "'INPUT=1'"
            }
            CASE 11:
            {
                SEND_COMMAND vdvDS60,"'INPUT=2'"
            }
            CASE 12:
            {
                SEND_COMMAND vdvDS60,"'INPUT=3'"
            }
            CASE 13:
            {
                SEND_COMMAND vdvDS60,"'INPUT=4'"
            }	    
            CASE 14:
            {
                SEND_COMMAND vdvDS60,"'INPUT=5'"
            }	    
            CASE 15:
            {
                SEND_COMMAND vdvDS60,"'INPUT=6'"
            }	    
            CASE 16:
            {
                SEND_COMMAND vdvDS60,"'INPUT=7'"
            }	    
            CASE 17:     // Digit 0 
            CASE 18:     // Digit 1
            CASE 19:     // Digit 2
            CASE 20:     // Digit 3
            CASE 21:     // Digit 4
            CASE 22:     // Digit 5
            CASE 23:     // Digit 6
            CASE 24:     // Digit 7 
            CASE 25:     // Digit 8
            CASE 26:     // Digit 9    
            {
                IF (LENGTH_STRING(sDirect) < 4)
                    sDirect = "sDirect,ITOA(nTPButtons[nBtnIndex]-nTPButtons[17])"
                    SEND_COMMAND dvTPArray,"'!T',nTPButtons[52],sDirect"
            }
            CASE 27:    // clear
            {
                sDirect =''
                SEND_COMMAND dvTPArray,"'!T',nTPButtons[52],sDirect"
            }
	    
            CASE 28: 
            {
                IF (LENGTH_STRING(sDirect))
                {
                    SEND_COMMAND vdvDS60,"'BRIGHTNESS=',sDirect"
                    sDirect =''
                    SEND_COMMAND dvTPArray,"'!T',nTPButtons[48],sDirect"
                }
            }
            CASE 29:    
            {
                SEND_COMMAND vdvDS60, "'BRIGHTNESS=+'"
            }
            CASE 30:    
            {
                SEND_COMMAND vdvDS60, "'BRIGHTNESS=#'"
            }                                     
             CASE 31:    
            {
                SEND_COMMAND vdvDS60, "'BRIGHTNESS=-'"
            }
            CASE 32:    
            {
                SEND_COMMAND vdvDS60, "'BRIGHTNESS=='"
            }             
            CASE 33: 
            {
                IF (LENGTH_STRING(sDirect))
                {
                    SEND_COMMAND vdvDS60,"'COLOR=',sDirect"
                    sDirect =''
                    SEND_COMMAND dvTPArray,"'!T',nTPButtons[49],sDirect"
                }
            }
            CASE 34:    
            {
                SEND_COMMAND vdvDS60, "'COLOR=+'"
            }
            CASE 35:    
            {
                SEND_COMMAND vdvDS60, "'COLOR=#'"
            }                                     
             CASE 36:    
            {
                SEND_COMMAND vdvDS60, "'COLOR=-'"
            }
            CASE 37:    
            {
                SEND_COMMAND vdvDS60, "'COLOR=='"
            }             
            CASE 38: 
            {
                IF (LENGTH_STRING(sDirect))
                {
                    SEND_COMMAND vdvDS60,"'CONTRAST=',sDirect"
                    sDirect =''
                    SEND_COMMAND dvTPArray,"'!T',nTPButtons[50],sDirect"
                }
            }
            CASE 39:    
            {
                SEND_COMMAND vdvDS60, "'CONTRAST=+'"
            }
            CASE 40:    
            {
                SEND_COMMAND vdvDS60, "'CONTRAST=#'"
            }                                     
             CASE 41:    
            {
                SEND_COMMAND vdvDS60, "'CONTRAST=-'"
            }
            CASE 42:    
            {
                SEND_COMMAND vdvDS60, "'CONTRAST=='"
            }             
            CASE 43: 
            {
                IF (LENGTH_STRING(sDirect))
                {
                    SEND_COMMAND vdvDS60,"'TINT=',sDirect"
                    sDirect =''
                    SEND_COMMAND dvTPArray,"'!T',nTPButtons[51],sDirect"
                }
            }
            CASE 44:    
            {
                SEND_COMMAND vdvDS60, "'TINT=+'"
            }
            CASE 45:    
            {
                SEND_COMMAND vdvDS60, "'TINT=#'"
            }                                     
             CASE 46:    
            {
                SEND_COMMAND vdvDS60, "'TINT=-'"
            }
            CASE 47:    
            {
                SEND_COMMAND vdvDS60, "'TINT=*'"
            }             

        }
     }    
}

DATA_EVENT[vdvDS60]
{
    STRING:
    {
        STACK_VAR char sName[32]
             
        

        SEND_STRING 0,"'Rcvd from Comm:',DATA.TEXT" 
                       
        sName = REMOVE_STRING (DATA.TEXT,'=',1)
        SWITCH (sName) 
        {
            CASE 'ASPECT=' :            
            {
                nAspect = ATOI(DATA.TEXT) 
            }
            CASE 'BRIGHTNESS=' :
            {
                nBrightness = ATOI(DATA.TEXT)
                SEND_COMMAND dvTPArray,"'!T',nTPButtons[48],ITOA(nBrightness)"
            }
            CASE 'COLOR=' :
            {
                nColor = ATOI(DATA.TEXT)
                SEND_COMMAND dvTPArray,"'!T',nTPButtons[49],ITOA(nColor)"
            }            
            CASE 'CONTRAST=' :
            {
                nContrast = ATOI(DATA.TEXT)
                SEND_COMMAND dvTPArray,"'!T',nTPButtons[50],ITOA(nContrast)"
            }        
            CASE 'DEBUG=' :            // debug = <state> 
            {
                bDebug = ATOI(DATA.TEXT) 
            }
                        
            CASE 'INPUT=' :
            {
                nInput = ATOI(DATA.TEXT) 
            }
            
            CASE 'POWER=' :
            {
                nPower = ATOI(DATA.TEXT)
            }
            CASE 'TINT=' :
            {
                nTint = ATOI(DATA.TEXT)
                SEND_COMMAND dvTPArray,"'!T',nTPButtons[51],ITOA(nTint)"
            }
            CASE 'VERSION=' :
            {
                cVersion = DATA.TEXT
            }

        }   // END OF -switch on name 
    }
    COMMAND:
    {
    }
    ONLINE:
    {
    }
    OFFLINE:
    {
    }
}

DATA_EVENT[dvTPArray]
{
    STRING:
    {
    }
    COMMAND:
    {
    }
    ONLINE:
    {
       SEND_COMMAND dvTPArray,"'!T',nTPButtons[52],''"
 
    }
    OFFLINE:
    {
    }
}

DEFINE_PROGRAM
